unit base;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, base64,Dialogs,Graphics, StdCtrls,FileUtil,
  process,Forms,resource,versiontypes,versionresource;

Const
    ret = #10;
    HK  = #39;        // Hochkomma für Strings
    backtick = #96;
Var
    ServerIP, FirewallIP : String;
    DNS_Ziel             : String;
    DNS_AnzahlServer     : Integer;
    DNS_Server           : Array[1..10] of String;
    UbuntuVersion : integer;


Function validIP(IP : String):Boolean;
Function IPauslesen:string;
Function Maskeauslesen:string;
Function ZerlegeIP(IP:string; VAR b1,b2,b3,b4 : integer): Boolean;
Function Ping(IP:String):real;
procedure Split(Delimiter: Char; Str: string; ListOfStrings: TStrings) ;
Function du_MB(pfad : string):real;
Function du_byte(pfad : string) : integer;
Function Befehl_exec(Befehl : String):String;
Function Befehl_execF(Befehl : String):String;
Function KernelInfo_sh:String;
Function KernelDel_sh:String;
FUNCTION resourceVersionInfo: STRING;

implementation

Function validIP(IP : string):Boolean;
Const
  zeichen = '0123456789.';
  bmax = 255;
Var
  n,L,pp      : integer;
  p1,p2,p3    : integer;
  b1,b2,b3,b4 : integer;
  s           : String;
Begin
 s  := Trim(IP);
 result := false;
 L  := length(s);
 pp := 0;
 for n:= 1 to L do
   Begin
     if pos(s[n],zeichen)=0 then exit;
     if s[n]='.' then inc(PP);
   end;
 if pp <> 3 then exit;
 p1 := pos('.',s);
 b1 := StrToIntDef(Copy(S,1,p1-1),bmax+1);
 s  := Copy(S,p1+1,L);
 p2 := pos('.',s);
 b2 := StrToIntDef(Copy(S,1,p2-1),bmax+1);
 s  := Copy(S,p2+1,L);
 p3 := pos('.',s);
 b3 := StrToIntDef(Copy(S,1,p3-1),bmax+1);
 b4 := StrToIntDef(Copy(S,p3+1,L),bmax+1);
 if (b1 <= bmax) and (b2 <= bmax)  and (b3 <= bmax) and (b4 <= bmax) then result := True;
end;

Function ZerlegeIP(IP:string; VAR b1,b2,b3,b4 : integer):Boolean;
Const
  zeichen = '0123456789.';
  bmax = 255;
Var
  n,L,pp      : integer;
  p1,p2,p3    : integer;
  s           : String;
Begin
 s  := Trim(IP);
 result := false;
 L  := length(s);
 pp := 0;
 for n:= 1 to L do
   Begin
     if pos(s[n],zeichen)=0 then exit;
     if s[n]='.' then inc(PP);
   end;
 if pp <> 3 then exit;
 p1 := pos('.',s);
 b1 := StrToIntDef(Copy(S,1,p1-1),bmax+1);
 s  := Copy(S,p1+1,L);
 p2 := pos('.',s);
 b2 := StrToIntDef(Copy(S,1,p2-1),bmax+1);
 s  := Copy(S,p2+1,L);
 p3 := pos('.',s);
 b3 := StrToIntDef(Copy(S,1,p3-1),bmax+1);
 b4 := StrToIntDef(Copy(S,p3+1,L),bmax+1);
 if (b1 <= bmax) and (b2 <= bmax)  and (b3 <= bmax) and (b4 <= bmax) then result := True;
end;
function IPauslesen:string;
Var
  ifconfig : TProcess;
  Ausgabe  : TStringList;
  ipListe  : TStringList;
  n,p1,p2  : integer;
begin
  ifconfig := TProcess.Create(nil);
  Ausgabe  := TStringList.create;
  ipListe  := TStringList.create;
    ifconfig.CommandLine := '/sbin/ifconfig';
    ifconfig.Options := ifconfig.Options+[poWaitOnExit,poUsePipes] ;
    ifconfig.execute;
    Ausgabe.LoadFromStream(ifconfig.output);
    result:='';
    if (Ausgabe.Count > 0) then
      Begin
        for n:= 0 to Ausgabe.count-1 do
          Begin
            p1 := Pos('inet Adresse',Ausgabe[n]);
            p2 := Pos('Bcast:',Ausgabe[n]);
            if (p1 > 0) and (p2 > 0) and (p2>p1+21)then
              Begin
                ipListe.append(Copy(Ausgabe[n],p1+13,p2-p1-15));
                break;
              end;
          end;
        result:=ipListe.text;
      end
    else
      Begin
        result :='';
      end;
  ifconfig.free;
  Ausgabe.free;
  ipListe.free;
end;

function Maskeauslesen:string;
Var
  ifconfig   : TProcess;
  Ausgabe    : TStringList;
  IPListe    : TStringList;
  n,p1,p2,p3 : integer;
begin
  ifconfig := TProcess.Create(nil);
  Ausgabe  := TStringList.create;
  ipListe  := TStringList.create;
    ifconfig.CommandLine := '/sbin/ifconfig';
    ifconfig.Options := ifconfig.Options+[poWaitOnExit,poUsePipes] ;
    ifconfig.execute;
    Ausgabe.LoadFromStream(ifconfig.output);
    result:='';
    if (Ausgabe.Count > 0) then
      Begin
        for n:= 0 to Ausgabe.count-1 do
          Begin
            p1 := Pos('inet Adresse',Ausgabe[n]);
            p2 := Pos('Bcast:',Ausgabe[n]);
            p3 := Pos('Maske:',Ausgabe[n]);
            if (p1 > 0) and (p2 > 0) and (p2>p1+21) and (p3>p2) then
              Begin
                ipListe.append(Trim(Copy(Ausgabe[n],p3+6,15)));
                break;
              end;
          end;
        result:=ipListe.text;
      end
    else
      Begin
        result :='';
      end;
  ifconfig.free;
  Ausgabe.free;
  ipListe.free;
end;

function Ping(IP:string):real;
Var
  Befehl      : TProcess;
  Ausgabe     : TStringList;
  n,p1,p2,p3  : integer;
  zeit        : real;
  Empfang     : Boolean;
begin
  Befehl   := TProcess.Create(nil);
  Ausgabe  := TStringList.create;
  Befehl.commandline := '/bin/ping -c1 '+IP;
  Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
  Befehl.Execute;
  Ausgabe.LoadFromStream(Befehl.Output);
  // ShowMessage(Ausgabe.text);
  Empfang  := false;
    if (Ausgabe.Count > 0) then
      Begin
        for n:= 0 to Ausgabe.count-1 do
          Begin
            p1 := Pos('time=',Ausgabe[n]);
            p2 := Pos('ms',Ausgabe[n]);
            p3 := Pos('1 received',Ausgabe[n]);
            if (p1 > 0) and (p2 > 0) and (p2>p1) then
              Begin
                zeit := StrToFloat(Copy(Ausgabe[n],p1+5,p2-p1-5));
              end;
            if p3 > 0 then Empfang := True;
          end;
      end;
  if not Empfang then result := -1
                 else result := zeit;
  Befehl.free;
  Ausgabe.free;
end;

procedure Split(Delimiter: Char; Str: string; ListOfStrings: TStrings) ;
begin
   ListOfStrings.Clear;
   ListOfStrings.Delimiter     := Delimiter;
   ListOfStrings.DelimitedText := Str;
end;

Function du_MB(Pfad : String):real;
Const
  ziffern = '0123456789';
Var
  Befehl  : TProcess;
  Ausgabe : TStringList;
  n       : integer;
  Zeile   : String;
Begin
 Befehl   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 Befehl.commandline := 'sh -c "/usr/bin/du -sc '+Pfad+'"';
 Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
 Befehl.Execute;
 Ausgabe.LoadFromStream(Befehl.Output);
 Zeile := Ausgabe[Ausgabe.count-1];
 n := Pos('insgesamt',Zeile);
 //ShowMessage(Befehl.commandline+ret+Ausgabe.text);
 if n=0 then result := 0
        else result := StrToInt(Trim(Copy(Zeile,1,n-1))) / 1024;
 Befehl.free;
 Ausgabe.free;;
end;

Function du_byte(Pfad : String):integer;
Const
  ziffern = '0123456789';
Var
  Befehl  : TProcess;
  Ausgabe : TStringList;
  n       : integer;
  Zeile   : String;
Begin
 if not FileExists(Pfad) then
   Begin
     result := -1
   end
 else
   Begin
     Befehl   := TProcess.Create(nil);
     Ausgabe  := TStringList.create;
     Befehl.commandline := 'sh -c "/usr/bin/du -bc '+Pfad+'"';
     Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
     Befehl.Execute;
     Ausgabe.LoadFromStream(Befehl.Output);
     Zeile := Ausgabe[Ausgabe.count-1];
     n :=0;
     While (Pos(Zeile[n+1],ziffern)>0) do inc(n);
     if n = 0 then result := -1
              else result := StrToInt(Trim(Copy(Zeile,1,n)));
     Befehl.free;
     Ausgabe.free;;
   end;
end;

Function Befehl_exec(Befehl : String):String;
Var
  PRC     : TProcess;
  Ausgabe : TStringList;
Begin
 PRC   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 PRC.commandline := Befehl;
 PRC.Options := PRC.Options + [poWaitOnExit, poUsePipes];
 PRC.Execute;
 Ausgabe.LoadFromStream(PRC.Output);
 Result := Ausgabe.text;
 PRC.free;
 Ausgabe.free;
 end;



Function Befehl_execF(Befehl : String):String;
Var
  PRC  : TProcess;
  Ausgabe, Fehler : TStringList;
Begin
 PRC   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 Fehler   := TStringList.create;
 PRC.commandline := Befehl;
 PRC.Options := PRC.Options + [poWaitOnExit, poUsePipes];
 PRC.Execute;
 Ausgabe.LoadFromStream(PRC.Output);
 Fehler.LoadFromStream(PRC.StDerr);
 Result := Trim(Ausgabe.text+ret+ret+Fehler.text);
 PRC.free;
 Ausgabe.free;
 Fehler.free;
end;

Function KernelInfo_sh:String;
Var
  Befehl    : TProcess;
  Ausgabe   : TStringList;
  Pfad,s,u  : String;
  p1,p2,n   : integer;
Begin
 u := GetEnvironmentVariable('USER');
 if u <>'root' then
   Begin
     Result := 'keine Info';
     exit;
   end;
 Befehl   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 Pfad     :=  ExtractFilePath(Application.ExeName);
 Befehl.commandline := Pfad+'kernelinfo.sh';
 Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
 Befehl.Execute;
 Ausgabe.LoadFromStream(Befehl.Output);
 //ShowMessage(Befehl.commandline+ret+Ausgabe.text);
 if Ausgabe.count >0 then
   Begin
     for n := 0 to Ausgabe.count-1 do
       begin
         p1 := pos('neu installiert',Ausgabe[n]);
         p2 := pos('zu entfernen',Ausgabe[n]);
         if (p1>0) and (p2>0) then
           Begin
             s := Copy(Ausgabe[n],p1+17, p2-p1-18);
             result := s+' Pakete';
           end;
       end;
   end
 else
   begin
     Result := 'keine Info'
   end;
 Befehl.free;
 Ausgabe.free;;
end;

Function KernelDel_sh:String;
Var
  Befehl    : TProcess;
  Ausgabe   : TStringList;
  Pfad,s    : String;
  p1,p2,n   : integer;
Begin
 Befehl   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 Pfad     :=  ExtractFilePath(Application.ExeName);
 Befehl.commandline := Pfad+'kerneldel.sh';
 Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
 Befehl.Execute;
 Ausgabe.LoadFromStream(Befehl.Output);
 //ShowMessage(Befehl.commandline+ret+Ausgabe.text);
 if Ausgabe.count >0 then
   Begin
     for n := 0 to Ausgabe.count-1 do
       begin
         p1 := pos('neu installiert',Ausgabe[n]);
         p2 := pos('zu entfernen',Ausgabe[n]);
         if (p1>0) and (p2>0) then
           Begin
             s := Copy(Ausgabe[n],p1+17, p2-p1-18);
             result := s+' Pakete';
           end;
       end;
   end
 else
   begin
     Result := 'keine Info'
   end;
 Befehl.free;
 Ausgabe.free;;
end;
FUNCTION resourceVersionInfo: STRING;

 (* Unlike most of AboutText (below), this takes significant activity at run-    *)
 (* time to extract version/release/build numbers from resource information      *)
 (* appended to the binary.                                                      *)

 VAR     Stream: TResourceStream;
         vr: TVersionResource;
         fi: TVersionFixedInfo;

 BEGIN
   RESULT:= '';
   TRY

 (* This raises an exception if version info has not been incorporated into the  *)
 (* binary (Lazarus Project -> Project Options -> Version Info -> Version        *)
 (* numbering).                                                                  *)

     Stream:= TResourceStream.CreateFromID(HINSTANCE, 1, PChar(RT_VERSION));
     TRY
       vr:= TVersionResource.Create;
       TRY
         vr.SetCustomRawDataStream(Stream);
         fi:= vr.FixedInfo;
         RESULT := 'Version ' + IntToStr(fi.FileVersion[0]) + '.' + IntToStr(fi.FileVersion[1]) +
                ' release ' + IntToStr(fi.FileVersion[2]) + ' build ' + IntToStr(fi.FileVersion[3]); // + eol;
         vr.SetCustomRawDataStream(nil)
       FINALLY
         vr.Free
       END
     FINALLY
       Stream.Free
     END
   EXCEPT
   END
 END { resourceVersionInfo } ;

end.
