unit DNS_unit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids,base;

type

  { TDNSForm }

  TDNSForm = class(TForm)
    Aktualisieren: TButton;
    Ed_DNSZiel: TEdit;
    Memo1: TMemo;
    Scliessen: TButton;
    SG: TStringGrid;
    StaticText1: TStaticText;
    procedure AktualisierenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    Procedure Dig(DNSIP : String; VAR Zeit,Antwort : String) ;
    { private declarations }
  public
    { public declarations }
  end;

var
  DNSForm: TDNSForm;

implementation

{$R *.lfm}

{ TDNSForm }

procedure TDNSForm.AktualisierenClick(Sender: TObject);
Var
  n : integer;
  Zeit,Antwort : String;
begin
  if Trim(ED_DNSZiel.text)='' then ED_DNSZiel.text := 'www.heise.de';
  for n := 1 to SG.RowCount-1 do
    Begin
      Dig(SG.cells[2,n],Zeit,Antwort);
      SG.cells[3,n] := Zeit;
      SG.cells[4,n] := Antwort;
    end;
end;

procedure TDNSForm.FormShow(Sender: TObject);
Var
  n     : integer;
  Zeile : TStringList;
begin
  Zeile := TStringList.create;
  SG.RowCount:=3;
  ED_DNSZiel.text := DNS_Ziel;
  for n := 1 to SG.ColCount-1 do SG.ColWidths[n] := 140;;
  SG.Cells[1,0] :='DNS-Server';
  SG.Cells[2,0] :='IP DNS Server';
  SG.Cells[3,0] :='Antwortzeit';
  SG.Cells[4,0] :='Antwort';

  SG.Cells[1,1] :='Server';     SG.Cells[2,1] :=ServerIP;
  SG.Cells[1,2] :='Firewall';   SG.Cells[2,2] :=FirewallIP;
  if (DNS_AnzahlServer = 0) then
    Begin
      DNS_AnzahlServer := 7;
      DNS_Server[1] := 'OpenNIC(DE),82.211.31.248';
      DNS_Server[2] := 'Google,8.8.8.8';
      DNS_Server[3] := 'OpenDNS(USA),208.67.222.222';
      DNS_Server[4] := 'T-Online,194.25.2.129';
      DNS_Server[5] := 'Hansenet,213.191.74.18';
      DNS_Server[6] := 'Belwue,129.143.2.1';
      DNS_Server[7] := 'Kabel-BW,82.212.62.62';
    end;
  SG.RowCount:=3 + DNS_AnzahlServer;
  for n := 1 to DNS_AnzahlServer do
    Begin
      Zeile.commatext := DNS_Server[n];
      if Zeile.count=2 then
        Begin
          SG.Cells[1,n+2] := Zeile[0];
          SG.Cells[2,n+2] := Zeile[1];
        end
       else ShowMessage('Fehler bei der DNS-Server-Liste');
    end;
  for n := 1 to SG.RowCount-1 do SG.Cells[0,n]:= IntToStr(n);
  Zeile.free;
  AktualisierenClick(nil);
end;

procedure TDNSForm.Dig(DNSIP: String; VAR Zeit,Antwort : String);
Var
  output,Zeile : TStringList;
  n,m,z : integer;
  s : String;
begin
  output:= TStringList.create;
  Zeile := TSTringList.create;
  output.text := Befehl_exec('dig @'+DNSIP+' '+ED_DNSZiel.text+' +time=1 +tries=1');
  //ShowMessage(output.text);
  Zeit := '';
  Antwort := 'keine';
  for n := 0 to output.Count-1 do
    Begin
      if Pos(';; Query time:',output[n])=1 then Zeit := Copy(output[n],15,length(output[n])-14);
      if Pos(';; ANSWER SECTION:',output[n])=1 then
          Begin
            if Pos(ED_DNSZiel.text,output[n+1])=1 then
                Begin
                  s := output[n+1];
                  z :=0;
                  for m := length(s) downto 1 do
                    Begin
                      if s[m]='A' then z := m
                    end;
                  Antwort := Trim(Copy(s,z+1,length(s)-z));
                end;
          end;
    end;
  if (Zeit <>'') and (Pos('status: REFUSED',output.text)>0) then Antwort :='REFUSED';
  Zeit:=Trim(Zeit);
  output.free;
  Zeile.free;
end;

end.

